﻿Imports System.Collections.ObjectModel
Imports Telerik.Windows.Controls

Class MainWindow

    Public Sub New()
        InitializeComponent()

        Me.TrootItem.ItemsSource = New ObservableCollection(Of GeographicalDevision)() From { _
            New GeographicalDevision() With { _
                .Name = "Div 1" _
            } _
        }
    End Sub

    Private Sub txtNewCountry_KeyDown(sender As Object, e As KeyEventArgs)

    End Sub


    Private Sub txtNewEntry_KeyDown(sender As Object, e As KeyEventArgs)
        If e.Key = Key.Enter Then
            Dim control = DirectCast(sender, RadWatermarkTextBox)

            Dim geoDev = TryCast(control.DataContext, GeographicalDevision)
            Dim tag As RadTreeViewItem = TryCast(control.Tag, RadTreeViewItem)
            Dim nEntry = New GeographicalDevision() With { _
                .Name = control.Text, _
                .Parent = geoDev _
            }
            geoDev.GeographicalDevisions.Add(nEntry)
            control.Clear()
        End If
    End Sub
End Class

Public Class GeographicalDevision
    Public Sub New()
        Me.GeographicalDevisions = New ObservableCollection(Of GeographicalDevision)()
    End Sub

    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(value As String)
            m_Name = value
        End Set
    End Property
    Private m_Name As String
    Public Property Parent() As GeographicalDevision
        Get
            Return m_Parent
        End Get
        Set(value As GeographicalDevision)
            m_Parent = value
        End Set
    End Property
    Private m_Parent As GeographicalDevision
    Public Property GeographicalDevisions() As ObservableCollection(Of GeographicalDevision)
        Get
            Return m_GeographicalDevisions
        End Get
        Set(value As ObservableCollection(Of GeographicalDevision))
            m_GeographicalDevisions = value
        End Set
    End Property
    Private m_GeographicalDevisions As ObservableCollection(Of GeographicalDevision)
End Class
